F - 6

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input

3
1033 8179
1373 8017
1033 1033

参考别人代码做的题,自己写的一直报错
Sample Output

6
7
0

代码如下

#include<stdio.h>
#include<string.h>
#include<queue>
using namespace std;
#define maxn 10010
int book[maxn];
int vis[maxn];
int step[maxn];
int n,m;
void prime()
{
    memset(book,0,sizeof(book));
    for(int i=2; i*i<maxn; i++)
    {
        if(book[i]==0)
        {
            for(int j=i*i; j<maxn; j+=i)
                book[j]=1;
        }
    }
    return ;
}

bool check(int x,int y)
{
    int x1,x2,x3,x4;
    int y1,y2,y3,y4;
    x1=x/1000;
    y1=y/1000;
    x2=(x-(x/1000)*1000)/100;
    y2=(y-(y/1000)*1000)/100;
    x4=x%10;
    y4=y%10;
    x3=(x-(x1*1000)-(x2*100)-x4)/10;
    y3=(y-(y1*1000)-(y2*100)-y4)/10;
    int num=0;
    if(x1==y1) num++;
    if(x2==y2) num++;
    if(x3==y3) num++;
    if(x4==y4) num++;
    if(num==3)
        return 1;
    else
        return 0;
}
int bfs(int n,int m)
{
    memset(vis,0,sizeof(vis));
    memset(step,-1,sizeof(step));
    queue<int>q;
    while(!q.empty())
        q.pop();
    q.push(n);
    vis[n]=1;
    step[n]=0;
    while(!q.empty())
    {
        int cur=q.front();
        if(cur==m)
        return 1;
        q.pop();
        for(int i=1000; i<maxn; i++)
        {
            if(!vis[i]&&!book[i]&&check(cur,i)&&step[i]==-1)
            {
                q.push(i);
                vis[i]=1;
                step[i]=step[cur]+1;
            }
        }
    }
    return 0;
}
int main()
{
    prime();
    int t;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d %d",&n,&m);
        if(bfs(n,m)) printf("%d\n",step[m]);
        else printf("Impossible\n");
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值